<?php

namespace Ems\portalGestor\Repository;

use Doctrine\ORM\EntityManager;
use Doctrine\DBAL\Connection;

class PeriodoRepository {
    /** @var Connection */
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection           = $entityManager->getConnection();
    }

    public function get(
        int $nrOrg,
        int $nrPeriodo
    ) {
        $sql = <<<SQL
            SELECT
                PA.*
            FROM
                PTO_PERIODOAPURACAO PA
            WHERE
                PA.NRORG = :P_NRORG AND
                PA.NRPERIODOAPURACAO = :P_NRPERIODO
SQL;

        $params = [
            'P_NRORG' => $nrOrg,
            'P_NRPERIODO' => $nrPeriodo,
        ];

        $std = $this->connection->prepare($sql);
        $std->execute($params);

        $periodo = $std->fetch();

        return $periodo;
    }

    public function getPeriodoByDtIniNrTipoVinculo(
        array $params
    ) {
        $sql = <<<SQL
            SELECT
                PA.*
            FROM
                PTO_PERIODOAPURACAO PA
                JOIN PTO_TIPOPERIODOAPURACAO TP ON
                    TP.NRORG = PA.NRORG AND
                    TP.NRTIPOPERIODOAPURACAO = PA.NRTIPOPERIODOAPURACAO
            WHERE
                PA.NRORG = :P_NRORG AND
                PA.DTINICIALAPURACAO = :P_DTINICIAL AND
                TP.NRTIPOVINCULOM = :P_NRTIPOVINCULO
SQL;

        $std = $this->connection->prepare($sql);
        $std->execute($params);

        $periodo = $std->fetch();

        return $periodo;
    }
}