<?php
namespace EMS\portalGestor\Service;

use Doctrine\ORM\EntityManager;
use Ems\portalGestor\Util\HcmServices;

use EMS\portalGestor\Util\DateUtil;

class ProcessoService {

    /** @var HcmServices */
    protected $hcmServices;

    public function __construct(
        HcmServices     $hcmServices
    ) {
        $this->hcmServices = $hcmServices;
    }

    public function getStatusProcesso(
        int $nrOrg
    ): array {
        $route = 'getStatusProcesso';

        $params = [
            'requestType' => 'Row',
            'row' => [
                'EMPTY' => null,
            ],
        ];

        $result = $this->hcmServices->send($route, $params, $nrOrg);
        $motivos = $result['dataset'][$route];

        return $motivos;
    }

    public function getProcessosGestor(
        int $nrOrg,
        int $nrParcNegocio
    ): array {
        $route = 'getProcessosGestor';

        $params = [
            'requestType' => 'Row',
            'row' => [
                'NRPARCNEGOCIO' => $nrParcNegocio,
            ],
        ];

        $result = $this->hcmServices->send($route, $params, $nrOrg);
        $processos = $result['dataset'][$route];

        return $processos;
    }

    public function getFasesTemplate(
        int $nrOrg,
        int $nrTemplate
    ): array {
        $route = 'getFasesTemplate';

        $params = [
            'requestType' => 'Row',
            'row' => [
                'NRTEMPLATE' => $nrTemplate,
            ],
        ];

        $result = $this->hcmServices->send($route, $params, $nrOrg);
        $fases = $result['dataset'][$route];

        return $fases;
    }

    public function getCandidatosFase(
        int $nrOrg,
        int $nrProcesso,
        int $nrFase
    ): array {
        $route = 'getCandidatosFase';

        $params = [
            'requestType' => 'Row',
            'row' => [
                'NRPROCESSO' => $nrProcesso,
                'NRFASE' => $nrFase,
            ],
        ];

        $result = $this->hcmServices->send($route, $params, $nrOrg);
        $candidatos = $result['dataset'][$route];

        return $candidatos;
    }
}
