/*
Tabela PARAMCST -> Controle Fiscal - Situao Tributria
Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela PARAMCST
Criao: 12/04/2012 - Flvia Emlia Carvalho 
*/

CREATE OR REPLACE TRIGGER LOG_PARAMCST
AFTER DELETE OR INSERT OR UPDATE
ON PARAMCST FOR EACH ROW
DECLARE
  V_USUARIO      VARCHAR2(40);
  V_TIPO         VARCHAR2(1);
  V_ITPESQ       VARCHAR2(40);
  V_DESC         VARCHAR2(300);
  V_DTOPER       DATE;
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);

BEGIN
   V_TIPO := '0';
   V_DESC := '';

   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF DELETING THEN
      IF :OLD.IDENTRSAIDOP IS NOT NULL THEN
         V_DESC := V_DESC || ' E/S=' || :OLD.IDENTRSAIDOP;
      END IF;

      IF :OLD.CDIMPOSTO IS NOT NULL THEN
         V_DESC := V_DESC || ' CdImposto=' || :OLD.CDIMPOSTO;
      END IF;

      IF :OLD.CDSITUTRIB IS NOT NULL THEN
         V_DESC := V_DESC || ' CdSituTrib=' || :OLD.CDSITUTRIB;
      END IF;

      IF :OLD.DSSITUTRIB IS NOT NULL THEN
         V_DESC := V_DESC || ' DescSitTrib=' || :OLD.DSSITUTRIB;
      END IF;

      IF :OLD.IDOBRVRIMPOS IS NOT NULL THEN
         V_DESC := V_DESC || ' IdObrigaImposto=' || :OLD.IDOBRVRIMPOS;
      END IF;

      IF :OLD.IDUTILIZACST IS NOT NULL THEN
         V_DESC := V_DESC || ' UtilizaCST=' || :OLD.IDUTILIZACST;
      END IF;

      V_TIPO   := '3';
      V_ITPESQ := :OLD.IDENTRSAIDOP||:OLD.CDIMPOSTO;
   ELSE
      IF UPDATING THEN
         IF (NVL(:OLD.IDENTRSAIDOP,'!') <> NVL(:NEW.IDENTRSAIDOP,'!')) OR
            (NVL(:OLD.CDIMPOSTO,'!')    <> NVL(:NEW.CDIMPOSTO,'!'))    OR
            (NVL(:OLD.CDSITUTRIB,'!')   <> NVL(:NEW.CDSITUTRIB,'!'))   OR
            (NVL(:OLD.DSSITUTRIB,'!')   <> NVL(:NEW.DSSITUTRIB,'!'))   OR
            (NVL(:OLD.IDOBRVRIMPOS,'!') <> NVL(:NEW.IDOBRVRIMPOS,'!')) OR
            (NVL(:OLD.IDUTILIZACST,'!') <> NVL(:NEW.IDUTILIZACST,'!')) THEN

            IF (NVL(:OLD.IDENTRSAIDOP,'!') <> NVL(:NEW.IDENTRSAIDOP,'!')) THEN
               V_DESC := V_DESC || ' E/S=' || :NEW.IDENTRSAIDOP;
            END IF;

            IF (NVL(:OLD.CDIMPOSTO,'!') <> NVL(:NEW.CDIMPOSTO,'!')) THEN
               V_DESC := V_DESC || ' CdImposto=' || :NEW.CDIMPOSTO;
            END IF;

            IF (NVL(:OLD.CDSITUTRIB,'!') <> NVL(:NEW.CDSITUTRIB,'!')) THEN
               V_DESC := V_DESC || ' CdSituTrib=' || :NEW.CDSITUTRIB;
            END IF;

            IF (NVL(:OLD.DSSITUTRIB,'!') <> NVL(:NEW.DSSITUTRIB,'!')) THEN
               V_DESC := V_DESC || ' DescSitTrib=' || :NEW.DSSITUTRIB;
            END IF;

            IF (NVL(:OLD.IDOBRVRIMPOS,'!') <> NVL(:NEW.IDOBRVRIMPOS,'!')) THEN
               V_DESC := V_DESC || ' IdObrigaImposto=' || :NEW.IDOBRVRIMPOS;
            END IF;

            IF (NVL(:OLD.IDUTILIZACST,'!') <> NVL(:NEW.IDUTILIZACST,'!')) THEN
               V_DESC := V_DESC || ' UtilizaCST=' || :NEW.IDUTILIZACST;
            END IF;

            V_TIPO   := '2';
            V_ITPESQ := :OLD.IDENTRSAIDOP||:OLD.CDIMPOSTO;
         END IF;
      ELSE
         IF (NVL(:NEW.IDENTRSAIDOP,'!') <> NVL(:OLD.IDENTRSAIDOP,'!')) THEN
            V_DESC := V_DESC || ' E/S=' || :NEW.IDENTRSAIDOP;
         END IF;

         IF (NVL(:NEW.CDIMPOSTO,'!') <> NVL(:OLD.CDIMPOSTO,'!')) THEN
            V_DESC := V_DESC || ' CdImposto=' || :NEW.CDIMPOSTO;
         END IF;

         IF (NVL(:NEW.CDSITUTRIB,'!') <> NVL(:OLD.CDSITUTRIB,'!')) THEN
            V_DESC := V_DESC || ' CdSituTrib=' || :NEW.CDSITUTRIB;
         END IF;

         IF (NVL(:NEW.DSSITUTRIB,'!') <> NVL(:OLD.DSSITUTRIB,'!')) THEN
            V_DESC := V_DESC || ' DescSitTrib=' || :NEW.DSSITUTRIB;
         END IF;

         IF (NVL(:NEW.IDOBRVRIMPOS,'!') <> NVL(:OLD.IDOBRVRIMPOS,'!')) THEN
            V_DESC := V_DESC || ' IdObrigaImposto=' || :NEW.IDOBRVRIMPOS;
         END IF;

         IF (NVL(:NEW.IDUTILIZACST,'!') <> NVL(:OLD.IDUTILIZACST,'!')) THEN
            V_DESC := V_DESC || ' UtilizaCST=' || :NEW.IDUTILIZACST;
         END IF;

         V_TIPO   := '1';
         V_ITPESQ := :NEW.IDENTRSAIDOP||:NEW.CDIMPOSTO;
      END IF;
   END IF;

   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,     DTOPERACAO,   NMRESPOPER,  IDTIPOOPER,   CDPESQITEM,  DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('PARAMCST',     V_DTOPER,       V_USUARIO,     V_TIPO,         V_ITPESQ,       SUBSTR(V_DESC,1,300),
                V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVERRDM, V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_PARAMCST','5.50.xxx'); END;
/
